import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.event.*;
import javax.swing.*;
/*
I wrote the original of this in 1995 and now I'm rewriting it to show
my new skills in Java.  This is going to be a Windows based program, rather
than the DOS base of the original, so they might not look that much alike.
As with any good programmer, I hate to type, and I'll do as much Cut-and-Pasting
I can get away with, but I didn't get to do much of that here.  Almost
everything I did had to be custom made for this version, since they're that far
different and due to the different way I handled the different pieces.
*/

public class ScorFor {
  static JFrame F = new JFrame("ScorFor");
  static Grid P = new Grid();
  static boolean ShowNumbers = false;
  static boolean OnTop = true;
  static boolean OnBottom = false;
  static boolean Alternate = true;
  static TextField[] Scores = new TextField[3];
  static Cursor[] TheCursor = new Cursor[3];
  static ImageIcon[] Beads = new ImageIcon[2];
  static int Moves = 1; // keeps track of how many moves have been made
  static int[] Board = new int[16]; // trinary representation of the board in hex
  // each level of the peg has three options, no bead, white, black
  // and each level is represented by the powers of 3, only I have to work with
  // hex (octal) and make it "look" like a base three number

  static int pow(int num,int power){
  // takes two int's and returns the first number to the power of the second number
  // this way I don't have to include a whole library for a single operation
    int exp = num;
    if (power == 0){return 1;}
    if (power == 1) {return num;}
    for (int i = 2;i<=power;i++){
      exp = num * exp;
    }
    return exp;
  }

  public static void main (String[] args) {
    // sets up the "beads" and the cursors
    Beads[0] = new ImageIcon("White.gif");
    Beads[1] = new ImageIcon("Black.gif");
    TheCursor[0] = Toolkit.getDefaultToolkit().createCustomCursor(
      Beads[0].getImage(),new Point(16,16),"");
    TheCursor[1] = Toolkit.getDefaultToolkit().createCustomCursor(
      Beads[1].getImage(),new Point(16,16),"");
    TheCursor[2] = new Cursor(Cursor.DEFAULT_CURSOR);

    // sets up the menus and menu bar
    Menu MGame = new Menu("Game");
    MGame.add("New");
    MGame.add("Players");
    MGame.add("Exit");
    Menu MHelp = new Menu("Help");
    MHelp.add("Instructions");
    MHelp.add("About");
    MGame.addActionListener(new MenuLr());
    MHelp.addActionListener(new MenuLr());
    MenuLr.NewGame();
    MenuBar MenuBar1 = new MenuBar();
    MenuBar1.add(MGame);
    MenuBar1.add(MHelp);

    // sets up the panel used for the gameboard
    P.setBackground(new Color(10,185,10));
    P.addMouseListener(new MouseLr());

    // sets up the scoring boxes and the scorecard
    for (int i = 0;i<3;i++){
      Scores[i] = new TextField("0");
      Scores[i].setEditable(false);
      Scores[i].setBackground(Color.white);
    }
    Panel South = new Panel();
    South.setLayout(new GridLayout(1,6));
    South.setBackground(new Color(10,185,10));
    South.add(new Label("                   White: "));
    South.add(Scores[0]);
    South.add(new Label("                    Black: "));
    South.add(Scores[1]);
    South.add(new Label("                        Kat: "));
    South.add(Scores[2]);

    // sets up the frame for use
    F.setSize(600,480);
    F.setLocation(200,100);
    F.setResizable(false);
    F.getContentPane().add(P);
    F.getContentPane().add("South",South);
    F.setMenuBar(MenuBar1);
    F.setDefaultCloseOperation(3);
    F.setVisible(true);
  }

  static class Grid extends Panel{
  // Creates the gameboard.  Compare it to the original and laugh at it's simplicity
  // Also contains the falling effect, the checking device to see who wins, the
  // score keeper, and a few other things
    int[][] Winning = new int[4][2];
    Font MyFont = new Font("Helvetica",Font.BOLD,18);

    int[][] ResetWin(){ // returns a "null" value
      int[][] temp = {{-1,-1},{-1,-1},{-1,-1},{-1,-1}};
      return temp;
    }

    int ToInt(String temp){ // takes a string and returns an int
      int num = 0;
      int num2 = 0;
      for (int i = 0;i<temp.length();i++){
        if (temp.charAt(i)=='1'){num2 = 1;}
        if (temp.charAt(i)=='2'){num2 = 2;}
        if (temp.charAt(i)=='3'){num2 = 3;}
        if (temp.charAt(i)=='4'){num2 = 4;}
        if (temp.charAt(i)=='5'){num2 = 5;}
        if (temp.charAt(i)=='6'){num2 = 6;}
        if (temp.charAt(i)=='7'){num2 = 7;}
        if (temp.charAt(i)=='8'){num2 = 8;}
        if (temp.charAt(i)=='9'){num2 = 9;}
        if (temp.charAt(i)=='0'){num2 = 0;}
        num = (num*10) + num2;
      }
      return num;
    }

    void Score(int winner){ // the scorekeeper
      Scores[winner].setText(" "+(ToInt(Scores[winner].getText().toString())+1));
    }

    public void paint(Graphics g){
    // Creates the game board and refreshes any beads already on the board
      if ((Moves == 1)||(F.getCursor().equals(TheCursor[2]))){
        Winning = ResetWin();
      }else{
        if (Moves >5){
          Winning = CheckWin();
        }
      }
      int Color = 0;
      for (int i = 0;i<4;i++){ // draws the pegs
        for (int j = 0;j<4;j++){
          if (ShowNumbers&&OnTop){ // draws the peg numbers above the pegs, if needed
            g.setFont(MyFont);
            g.setColor(new Color(0,0,0));
            g.drawString(((i+1)+(j*4))+" ",(30*i)+(120*j)+65,(25*i)+65);
          }
          if (ShowNumbers&&OnBottom){ // draws the peg numbers above the pegs, if needed
            g.setFont(MyFont);
            g.setColor(new Color(0,0,0));
            g.drawString(((i+1)+(j*4))+" ",(30*i)+(120*j)+65,(25*(i+9))+70);
          }
          g.drawLine((30*i)+(120*j)+70,(25*i)+75,(30*i)+(120*j)+70,(25*i)+275);
        }
      }
      for (int i = 0;i<16;i++){ // redraws the beads where they should appear
        for (int j = 0;(j<4)&&(Board[i]>0);j++){
          Color = ((Board[i]&pow(8,j))/pow(8,j)) +
                  ((Board[i]&(2*pow(8,j)))/pow(8,j)) - 1;
          // figures out what color the beads should be
          if (Winning[1][0] != -1){ // draws a red circle around the winning beads
            for (int k = 0;k<4;k++){
              if ((Winning[k][0]==i)&&(Winning[k][1]==j)){
                g.setColor(new Color(255,0,0));
                for (int m = 0;m<4;m++){
                  g.drawOval((i*30)+54-m,(((3-j)*48)+74-m+(((i%4)+1)*25)),33+(m*2),33+(m*2));
          } } } }
          g.drawImage(Beads[Color].getImage(),((i*30)+55),(((3-j)*48)+75+(((i%4)+1)*25)),this);
          if (Board[i]<=pow(8,j+1)){j=5;}
    } } }

    int[][] CheckWin(){
    // Checks to see if anyone has won
      int i = 0; // main counter variable to sift through the board
      int k = 0; // generic counter variable to generate the peg numbers
      int j = 0; // generic counter variable to generate the bead height
      int[] Colors = new int[4]; // makes the if statement for checking for the win simpler
      int[][] Win = new int[4][2];
      // first number in each pair is the peg, the second number is the height
      // of the bead on the peg
      do { // starts the loop for peg generation and win checking
        if (i<4){ // checks the "columns" of the pegs first
          for (;k<(4*(i+1));k++){
            Win[k-(4*i)][0] = k;
          }
        } else { // checks the "rows" of the pegs next
          if (i<8){
            for (k=0;k<4;k++){
              Win[k][0] = (k*4)+(i-4);
            }
          } else { // checks one of the cross-board diagonals
            if (i==8){
              for (k=0;k<4;k++){
                Win[k][0] = k*5;
              }
            } else { // checks the other cross-board diagonal
              if (i==9){
                for (k=0;k<4;k++){
                  Win[k][0] = (k+1)*3;
                }
              } else { // checks for a straight up win
                if (i<26){
                  for (k=0;k<4;k++){
                    Win[k][0] = i-10;
        } } } } } }
        j = 0;
        do { // starts the loop for height creation and win checking
          if (i<10){
            if (j<4){ // checks for the horizontal win
              for (int g=0;g<4;g++){
                Win[g][1] = j;
              }
            } else { // checks for one of the diagonals
              if (j==4){
                for (int g=0;g<4;g++){
                  Win[g][1] = g;
                }
              } else { // checks for the other diagonal
                if (j==5){
                  for (int g=0;g<4;g++){
                    Win[g][1] = 3-g;
            } } } }
          }else {
            j=5;
            // this makes sure that the loop checks a straight up win only once
            // per peg and since the last loop above creates one of the necessary
            // combinations for a straight up win, {0,1,2,3} or {3,2,1,0}, I don't
            // have to assign Win[var][1] anything, plus it saves code and processor time
          }
          for (int m=0;m<4;m++){ // gets the colors for the beads to be compared
            Colors[m] = ((Board[Win[m][0]]&pow(8,Win[m][1]))/pow(8,Win[m][1])) +
                        ((Board[Win[m][0]]&(2*pow(8,Win[m][1])))/pow(8,Win[m][1])) - 1;
          }
          if ((Colors[0]==Colors[1])&&(Colors[2]==Colors[3])&&
              (Colors[0]==Colors[2])&&(Colors[0]!=-1)){
            // this does the actual check and returns the values for a win
            Score(Colors[0]); // tells the score keeper who won
            F.setCursor(TheCursor[2]);
            return Win;
          }
          j++;
        } while (j<6); // ends the height creation and checking loop
        i++;
      }while (i<(26+(MenuLr.Players%2))); // ends the check for a win and the peg generating loop
      if (Moves==65){ // checks to see if no one won
        Win = ResetWin(); // gets a "null" value to send back
        Win[1][0] = 0; // makes sure that there are no red circles
        Score(2); // tells the score keeper that no one won
        F.setCursor(TheCursor[2]);
        return Win;
      }
      return ResetWin();  // returns a "null" value for no win
    }

    void FallingBead(Graphics G,int Peg,int y,int color){
    // Creates the falling effect of the beads
      int EndY = (((3-y)*48)+75+(((Peg%4)+1)*25));
      int x = ((Peg*30)+55);
      for (int FallY = (15+(((Peg%4)+1)*25));FallY<EndY;FallY+=5){
        try{Thread.currentThread().sleep(5);}catch(Exception E){System.out.println(E);}
        G.clearRect(x,FallY-5,32,32); // removes the bead
        if ((FallY > (75+((Peg%4)*25)))){
          G.drawLine(x+15,FallY-5,x+15,FallY+27);
        } // replaces the peg where the bead used to be
        G.drawImage(Beads[color].getImage(),x,FallY,this);
      }
      repaint();
    }
  }

  static class MouseLr implements MouseListener{
  // takes care of recieving, deciphering, and allowing each move
    MouseEvent e;
    public void mouseReleased(MouseEvent E){
      // figures out where the player clicked
      int Peg = (E.getX()-55)/30;
      int y = (E.getY()-75-((Peg%4)*25))/50;
      if ((((e.getX()-55)/30) == Peg)&&(e.getY() >= (55+((Peg%4)*25)))&&
          (((e.getY()-75-((Peg%4)*25))/50)<4)){
        if (E.getY() < (55+((Peg%4)*25))) {y = -1;}
        if ((Peg >= 0)&&(Peg < 16)&&(y >= 0)&&(y < 4)&&(!F.getCursor().equals(TheCursor[2]))){
        // the above line figures out if the move is valid or if the peg is full
        // if the game is over, i.e. the cursor is the default cursor, the move is not valid
          for (int j =0;j<4;j++){
            if ((Board[Peg])<pow(8,j)){
              P.FallingBead(P.getGraphics(),Peg,j,(Moves+1)%2);
              Board[Peg] += (((Moves+1)%2)+1)*pow(8,j);
              y = j;
              j=5;
              F.setCursor(TheCursor[((Moves)%2)]);
              Moves++;
    } } } } }
    public void mousePressed(MouseEvent E){e=E;}
    public void mouseEntered(MouseEvent E){e=E;}
    public void mouseExited(MouseEvent E){e=E;}
    public void mouseClicked(MouseEvent E){e=E;}
  }

  static class Mouser implements MouseListener{
  // takes care of the OK and Cancel buttons
    MouseEvent e;
    public void mouseReleased(MouseEvent E){
      if ((((JButton)E.getComponent()).getText() == ((JButton)e.getComponent()).getText())&&
         (MenuLr.Msg != null)){
        if (((JButton)E.getComponent()).getText() == "OK"){ // OK button
          ShowNumbers = MenuLr.Numbered[0].getState();
          if (ShowNumbers){
            OnTop = MenuLr.Numbered[1].getState();
            OnBottom = MenuLr.Numbered[2].getState();
          }
          Alternate = MenuLr.FirstMove[2].getState();
          if (MenuLr.FirstMove[0].getState() == true){ // White moves first
            MenuLr.Players = 1;
          }else{ // Black moves first
            MenuLr.Players = 0;
          }
          MenuLr.NewGame(); // resets the board
        }
        // always runs whether it is the Cancel or OK button
        F.setEnabled(true);
        MenuLr.Msg.setVisible(false);
        MenuLr.Msg = null;
      }
    }
    public void mouseEntered(MouseEvent E){e=E;}
    public void mouseExited(MouseEvent E){e=E;}
    public void mouseClicked(MouseEvent E){e=E;}
    public void mousePressed(MouseEvent E){e=E;}
  }

  static class MenuLr extends ScorFor implements ActionListener{
  // takes care of the menus and creates new games
    static JFrame Msg;
    static int Players = 1;
    static Checkbox[] FirstMove = new Checkbox[3];
    static Checkbox[] Numbered = new Checkbox[3];
    JButton Ok = new JButton("OK");
    JButton Cancel = new JButton("Cancel");
    MouseListener Closer = new MouseListener(){
      MouseEvent e;
      public void mouseReleased(MouseEvent E){
        F.setEnabled(true);
        Msg.setVisible(false);
        Ok.removeMouseListener(Closer);
        Msg = null;
      }
      public void mouseEntered(MouseEvent E){e=E;}
      public void mouseExited(MouseEvent E){e=E;}
      public void mouseClicked(MouseEvent E){e=E;}
      public void mousePressed(MouseEvent E){e=E;}
    };

    static public void NewGame(){
    // creates a new game and resets everything accordingly
      Moves = 0+(Players%2);
      for (int i = 0;i<16;i++){
        Board[i] = 0;
      }
      F.setCursor(TheCursor[(Players+1)%2]);
      P.repaint();
      if (Alternate){
        Players++;
      }
    }

    public void actionPerformed(ActionEvent e){
    // takes care of the menus
      if (e.getActionCommand() == "Exit") {
        System.exit(0);
      } else {
        if (e.getActionCommand() == "New") {
          NewGame();
        } else {
          if (e.getActionCommand() == "Players") {
            Msg = new JFrame("Players");
            F.setEnabled(false);

            CheckboxGroup Group1 = new CheckboxGroup();
            FirstMove[0] = new Checkbox("White",Group1,(Players%2)==1);
            FirstMove[1] = new Checkbox("Black",Group1,(Players%2)==0);
            FirstMove[2] = new Checkbox("Alternate",Alternate);

            Numbered[0] = new Checkbox("Yes",ShowNumbers);
            Numbered[1] = new Checkbox("Above",OnTop);
            Numbered[2] = new Checkbox("Below",OnBottom);
            Numbered[1].setEnabled(ShowNumbers);
            Numbered[2].setEnabled(ShowNumbers);
            Numbered[0].addItemListener(new ItemListener(){
              public void itemStateChanged(ItemEvent e){
                for (int j = 1;j<3;j++) {
                    Numbered[j].setEnabled(Numbered[0].getState());
              } }
            });

            Ok.addMouseListener(new Mouser());
            Cancel.addMouseListener(new Mouser());

            Panel Center = new Panel(new GridLayout(7,2));
            Center.add(new Label("First Move:"));
            for (int i = 0;i<3;i++){
              Center.add(FirstMove[i]);
              Center.add(new Label(" "));
            }
            Center.add(new Label(" "));
            Center.add(new Label("Numberd Pegs:"));
            for (int i = 0;i<3;i++){
              Center.add(Numbered[i]);
              if (i!=2){
                Center.add(new Label(" "));
              }
            }


            Panel South = new Panel(new  GridLayout(1,2));
            South.add(Ok);
            South.add(Cancel);

            Msg.setResizable(false);
            Msg.setSize(250,250);
            Msg.setLocation(300,200);
            Msg.setDefaultCloseOperation(0);
            Msg.getContentPane().add("Center",Center);
            Msg.getContentPane().add("South",South);
            Msg.setVisible(true);
          } else {
            if (e.getActionCommand() == "Instructions") { // instructions
              Msg = new JFrame("Instructions");
              F.setEnabled(false);

              TextArea Center = new TextArea(" ",15,10,TextArea.SCROLLBARS_VERTICAL_ONLY);
              Center.setEditable(false);
              Center.setText("    Welcome to ScorFor! This is a fun and challenging ");
              Center.append("game of 3D Tic Tac Toe.  Instead of getting three ");
              Center.append("in a row to win, you need to get four in a row.  ");
              Center.append("This is based on the original physical version which ");
              Center.append("works on a peg and bead basis.  There are four rows of ");
              Center.append("four pegs that stick up out of the gameboard, on which ");
              Center.append("beads are placed.  \n");
              Center.append("     This game works on the same basis.  If you");
              Center.append("look at the gameboard, you will notice 16 lines or ");
              Center.append("pegs.  These will be where you place your colored ");
              Center.append("beads.  There's the white bead and the black bead.  ");
              Center.append("Your mouse pointer will show you which color bead is");
              Center.append("going to be used.  All you have to do is click on the ");
              Center.append("peg you want to place your bead on.  Only four beads ");
              Center.append("fit on a peg, so once a peg gets full, you can't put ");
              Center.append("any more beads on it. \n");
              Center.append("     It may take awhile to get used to looking at ");
              Center.append("the gameboard, so just take your time.  The pegs ");
              Center.append("which are on the same level horizontally are in the ");
              Center.append("same row and the pegs that step down from each other ");
              Center.append("are on the same column.  You might try thinking about ");
              Center.append("each peg having a number 1 through 16 placed above them. ");
              Center.append("Each time you hit a multiple of 4, a new column ");
              Center.append("starts.  You can also select, in the Players menu, to ");
              Center.append("show the numbers of each peg either above or below the ");
              Center.append("peg. \n ");
              Center.append("     To win, all you have to do is get 4 of your beads ");
              Center.append("in a straight row.  It won't really look straight until ");
              Center.append("you get the hang of looking at the board.  Winning can be ");
              Center.append("done in a number of ways.  Straight up a peg, diagonally, ");
              Center.append("horizontally, or any combination as long as it's a  ");
              Center.append("straight shot, it's a win.  Once there is a win, the ");
              Center.append("winning beads will be circled in red to show where ");
              Center.append("the winning combination is.  This makes it much easier ");
              Center.append("to figure out who, where, and why.  It can also be ");
              Center.append("helpful in figuring out how to look at the board and how ");
              Center.append("all the winning combinations can be made.  There are ");
              Center.append("quite a few different combinations, and many are not easy ");
              Center.append("to see without help. \n");
              Center.append("     Under the Game menu, you will find New, Players, and Exit. ");
              Center.append("Exit quits the program.  New starts a new game, either ");
              Center.append("in the middle of a current game or after someone has won.  ");
              Center.append("Players leads to a new window which lets you select  ");
              Center.append("who goes first in the new game and if the starting players ");
              Center.append("alternate automatically.  This window also lets you select ");
              Center.append("whether there is numbering above or below the pegs for easier ");
              Center.append("playing.  Once you hit the OK button, ");
              Center.append("a new game is started, so don't hit OK in the middle ");
              Center.append("of a game you want to continue.  Cancel is safe, though.  \n");
              Center.append("     I hope you have as much fun with this game as ");
              Center.append("I have had in the past.  This is a game for all ages and ");
              Center.append("abilities, as long as you don't try and swallow the beads.\n");
              Center.append("     Designed and tested on a 1800+ AMD, with Win 98 at  ");
              Center.append("1024x768 resolution.  Also tested at 800x600 resolution.");

              Panel South = new Panel(new  GridLayout(1,3));
              South.add(new Label(" "));
              South.add(Ok);
              Ok.addMouseListener(Closer);
              South.add(new Label(" "));

              Msg.setResizable(false);
              Msg.setSize(300,300);
              Msg.setLocation(300,200);
              Msg.setDefaultCloseOperation(0);
              Msg.getContentPane().add("Center",Center);
              Msg.getContentPane().add("South",South);
              Msg.setVisible(true);
            } else {
              if (e.getActionCommand() == "About") { // about box
                Msg = new JFrame("About");
                F.setEnabled(false);

                TextArea Center = new TextArea(" ",15,10,TextArea.SCROLLBARS_NONE);
                Center.setEditable(false);
                Center.setText("ScorFor version 1.1 \n");
                Center.append("CopyRight 2003 \n");
                Center.append("written by \n");
                Center.append("     Eric Ingamells \n\n");
                Center.append("based on the original game of Score For ");
                Center.append(" ");

                Panel South = new Panel(new  GridLayout(1,3));
                South.add(new Label(" "));
                South.add(Ok);
                Ok.addMouseListener(Closer);
                South.add(new Label(" "));

                Msg.setResizable(false);
                Msg.setSize(200,200);
                Msg.setLocation(300,200);
                Msg.setDefaultCloseOperation(0);
                Msg.getContentPane().add("Center",Center);
                Msg.getContentPane().add("South",South);
                Msg.setVisible(true);
} } } } } } } }